//+-----------------------------------------------------------------+
//|                                                   JS-MA-Day.mq4 |
//+-----------------------------------------------------------------+
//| HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH |
//| H\    \               http://wsforex.ru/               /    / H |
//| H )----)----------------------------------------------(----(  H |
//| H/    /       : wsforex.ru   \    \ H |
//| HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH |
//+-----------------------------------------------------------------+

#property copyright "wsforex@list.ru"
#property link      "http://wsforex.ru/"
//+-----------------------------------------------------------------+
//|  : .  -   -  "http://wsforex.ru/"       |
//+-----------------------------------------------------------------+
extern int     CloseHour      =  23;
extern int     MA.Period      =  27;
extern int     TakeProfit     =  0;     //  TakeProfit=0    :
extern int     StopLoss       =  860;   //  StopLoss=0     
extern int     Slippage       =  10;    //  :  
extern int     NumberOfTry    =  5;     //     :
extern bool    MM             =  false; // MM    =False   
extern double  MaxRisk        =  3.3;   //      
extern double  Lots           =  0.01;
extern int     MagicNumber    =  7773777;
//+-----------------------------------------------------------------+
//|  : .  -   -  "http://wsforex.ru/"       |
//+-----------------------------------------------------------------+
extern bool    UseSound           =  True;  
extern bool    ShowComment        =  True; 
extern string  NameFileSound      =  "expert.wav";  //   
extern string  SoundSuccess       =  "expert.wav";  //  
extern string  SoundError         =  "timeout.wav"; //  
//+-----------------------------------------------------------------+
//|  : .  -   -  "http://wsforex.ru/"       |
//+-----------------------------------------------------------------+
extern bool    Ea.Disabled        =  False;  
extern color   clOpenBuy          =  LightBlue;  //    
extern color   clOpenSell         =  LightCoral; //    
extern color   clCloseBuy         =  Blue;       //    
extern color   clCloseSell        =  Red;        //    
//+-----------------------------------------------------------------+
//|  : .  -   -  "http://wsforex.ru/"       |
//+-----------------------------------------------------------------+
int init()
  {
//----
   if (!IsTesting()) {
    if (IsExpertEnabled()) Comment("\n      ");
    else Comment("\n!     ");
  }
//----
   return(0);
  }
//+-----------------------------------------------------------------+
//|  : .  -   -  "http://wsforex.ru/"       |
//+-----------------------------------------------------------------+
string Dayof(){
string dd;
  switch(DayOfWeek()){
    case 1: dd=""; break;
    case 2: dd="";     break;
    case 3: dd="";       break;
    case 4: dd="";     break;
    case 5: dd="";     break;
    case 6: dd="";     break;
    case 7: dd=""; break;
  }
  return(dd);
}
//+-----------------------------------------------------------------+
//|  : .  -   -  "http://wsforex.ru/"       |
//+-----------------------------------------------------------------+
string IIcm(int com){
 if(com==1)return(":"); else return(":");
}
//+-----------------------------------------------------------------+
//|  : .  -   -  "http://wsforex.ru/"       |
//+-----------------------------------------------------------------+
string shet(){
  string s;
  if (IsDemo())s=""; else s="";
  return(s);
}
//+-----------------------------------------------------------------+
//|  : .  -   -  "http://wsforex.ru/"       |
//+-----------------------------------------------------------------+
int start()
  {
//----
   RefreshRates();
   int lv=MarketInfo(Symbol(),MODE_STOPLEVEL);
// -----  
         
   Comment("\n   : - ",IIcm(Ea.Disabled==False),
           "\n: - ",Dayof(),
           "\n : - ",shet(),
           "\nSpread: - ",MarketInfo(Symbol(),MODE_SPREAD),
           "\nStopLevel: - ",MarketInfo(Symbol(),MODE_STOPLEVEL)
           );
//----
   if(Hour()>=CloseHour) 
   {
     ClosePos(OP_BUY, MagicNumber);
     ClosePos(OP_SELL, MagicNumber);
   }
   
   double sl,tp;
   RefreshRates();
   double ma0day =iMA(Symbol(), PERIOD_D1, MA.Period, 0, MODE_SMA, PRICE_MEDIAN, 0);
   double ma1day =iMA(Symbol(), PERIOD_D1, MA.Period, 0, MODE_SMA, PRICE_MEDIAN, 1);
   double ma2day =iMA(Symbol(), PERIOD_D1, MA.Period, 0, MODE_SMA, PRICE_MEDIAN, 2);
//----
   if(Hour()<2 && OrdersCount(Symbol(), OP_SELL, MagicNumber)==0
   && ma0day<ma1day && ma0day>iOpen(Symbol(), PERIOD_D1, 0) 
   && ma1day<ma2day && ma1day>iOpen(Symbol(), PERIOD_D1, 1)) {
   if(StopLoss>0) sl=Bid+StopLoss*Point; else sl=ma1day;
   if(TakeProfit>0) tp=Bid-TakeProfit*Point; else tp=0;
   if((sl-Bid)/Point>lv) { OpenPosition(Symbol(), OP_SELL, GetLots(), sl, tp, MagicNumber); 
     }
   }
   if(Hour()<2 && OrdersCount(Symbol(), OP_BUY, MagicNumber)==0
   && ma0day>ma1day && ma0day<iOpen(Symbol(), PERIOD_D1, 0)
   && ma1day>ma2day && ma1day<iOpen(Symbol(), PERIOD_D1, 1)) {
   if(StopLoss>0) sl=Ask-StopLoss*Point; else sl=ma1day;
   if(TakeProfit>0) tp=Ask+TakeProfit*Point; else tp=0;
   if((Ask-sl)/Point>lv) { OpenPosition(Symbol(), OP_BUY, GetLots(), sl, tp, MagicNumber);
     }
   }
//----
   return(0);
  }
//+-----------------------------------------------------------------+
//|  : .  -   -  "http://wsforex.ru/"       |
//+-----------------------------------------------------------------+
int OpenPosition(string sy,int op,double ll,double sl=0,double tp=0,int mn=0) 
{
  color    clOpen;
  datetime ot;
  double   pp, pa, pb;
  int      dg, err, it, ticket=0;
  string   lsComm=" ";
//+----
  if (sy=="" || sy=="0") sy=Symbol();
  if (op==OP_BUY) clOpen=clOpenBuy; else clOpen=clOpenSell;
  for (it=1; it<=NumberOfTry; it++) {
    if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
    while (!IsTradeAllowed()) Sleep(5000);
    RefreshRates();
    dg=MarketInfo(sy, MODE_DIGITS);
    pa=MarketInfo(sy, MODE_ASK);
    pb=MarketInfo(sy, MODE_BID);
    if (op==OP_BUY) pp=pa; else pp=pb;
    pp=NormalizeDouble(pp, dg);
    sl=NormalizeDouble(sl, dg);
    tp=NormalizeDouble(tp, dg);
    ot=TimeCurrent();
    ticket=OrderSend(sy, op, ll, pp, Slippage, sl, tp, lsComm, mn, 0, clOpen);
    if (ticket>0) {
    if (UseSound) PlaySound(NameFileSound); break;
    } else {
    err=GetLastError();
    if (err==128 || err==142 || err==143) {
    Sleep(1000*66.666);
    if (ExistPositions(sy, op, mn, ot)) {
    if (UseSound) PlaySound(NameFileSound); break;
    }
   }
    Print("Error(",err,") opening position: ",error(err),", try ",it);
    Print("Ask=",pa," Bid=",pb," sy=",sy," ll=",ll," op=",GetNameOP(op),
            " pp=",pp," sl=",sl," tp=",tp," mn=",mn);
    if (pa==0 && pb==0) Message("      "+sy);
    if (err==2 || err==64 || err==65 || err==133) {
    Ea.Disabled=True; break;
    }
    if (err==4 || err==131 || err==132) {
    Sleep(1000*300); break;
    }
    if (err==140 || err==148 || err==4110 || err==4111) break;
    if (err==141) Sleep(1000*100);
    if (err==145) Sleep(1000*17);
    if (err==146) while (IsTradeContextBusy()) Sleep(1000*11);
    if (err!=135) Sleep(1000*7.7);
    }
  }
  return(ticket);
}
//+-----------------------------------------------------------------+
//|  : .  -   -  "http://wsforex.ru/"       |
//+-----------------------------------------------------------------+
bool ExistPositions(string sy="", int op=-1, int mn=-1, datetime ot=0) {
  int i, k=OrdersTotal();
  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sy || sy=="") {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (ot<=OrderOpenTime()) return(True);
            }
          }
        }
      }
    }
  }
  return(False);
}
//+-----------------------------------------------------------------+
//|  : .  -   -  "http://wsforex.ru/"       |
//+-----------------------------------------------------------------+
string GetNameOP(int op) {
  switch (op) {
    case OP_BUY      : return("Buy");
    case OP_SELL     : return("Sell");
    case OP_BUYLIMIT : return("Buy Limit");
    case OP_SELLLIMIT: return("Sell Limit");
    case OP_BUYSTOP  : return("Buy Stop");
    case OP_SELLSTOP : return("Sell Stop");
    default          : return("Unknown Operation");
  }
}
//+-----------------------------------------------------------------+
//|  : .  -   -  "http://wsforex.ru/"       |
//+-----------------------------------------------------------------+
void Message(string m) {
  Comment(m);
  if (StringLen(m)>0) Print(m);
}
//+-----------------------------------------------------------------+
//|  : .  -   -  "http://wsforex.ru/"       |
//+-----------------------------------------------------------------+
int OrdersCount(string sy="", int op=-1, int mn=0)
{
//+----
  int orders=0;
  int cnt=OrdersTotal();
  for (int i=0; i<cnt; i++) {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
    if (OrderMagicNumber()!=mn) continue;
    if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
    if (OrderType()==OP_BUY || OrderType()==OP_SELL) { orders++;
    }
   }
  }
//+----
  return (orders);
}
//+-----------------------------------------------------------------+
//|  : .  -   -  "http://wsforex.ru/"       |
//+-----------------------------------------------------------------+
void ClosePos(int type, int mn=-1) {
  bool   fc;
  color  clClose;
  double ll, pa, pb, pp;
  int    i, k=OrdersTotal();
  int    dg=MarketInfo(OrderSymbol(), MODE_DIGITS), err, it;

  for (i=k-1; i>=0; i--) {
  if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
  if (OrderType()==type && OrderMagicNumber()==mn) {
    for (it=1; it<=NumberOfTry; it++) {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      pa=MarketInfo(OrderSymbol(), MODE_ASK);
      pb=MarketInfo(OrderSymbol(), MODE_BID);
      if (OrderType()==OP_BUY) {
        pp=pb; clClose=clCloseBuy;
      } else {
        pp=pa; clClose=clCloseSell;
      }
      ll=OrderLots();
      pp=NormalizeDouble(pp, dg);
      fc=OrderClose(OrderTicket(), ll, pp, Slippage, clClose);
      if (fc) {
        if (UseSound) PlaySound(SoundSuccess); break;
      } else {
        err=GetLastError();
        if (UseSound) PlaySound(SoundError);
        if (err==146) while (IsTradeContextBusy()) Sleep(1000*11);
        Print("Error(",err,") Close ",GetNameOP(OrderType())," ",
              error(err),", try ",it);
        Print(OrderTicket(),"  Ask=",pa,"  Bid=",pb,"  pp=",pp);
        Print("sy=",OrderSymbol(),"  ll=",ll,"  sl=",OrderStopLoss(),
              "  tp=",OrderTakeProfit(),"  mn=",OrderMagicNumber());
        Sleep(1000*5);
          }
        }
      }
    }
  }
}
//+-----------------------------------------------------------------+
//|  : .  -   -  "http://wsforex.ru/"       |
//+-----------------------------------------------------------------+
double GetLots(){
//---
 double Lot=Lots;
 if(!MM)return(Lot);
 double Free =AccountFreeMargin();
 double LotVal =MarketInfo(Symbol(),MODE_TICKVALUE);
 double Min_Lot =MarketInfo(Symbol(),MODE_MINLOT);
 double Max_Lot =MarketInfo(Symbol(),MODE_MAXLOT);
 double Step =MarketInfo(Symbol(),MODE_LOTSTEP);
//---
 if(StopLoss>0){ 
 Lot=MathFloor((Free*MaxRisk/100)/(StopLoss*LotVal)/Step)*Step;
 }else{ 
 Lot=MathFloor((Free*MaxRisk/100)/(1000*LotVal)/Step)*Step;
 }
 if(Lot<Min_Lot) Lot=Min_Lot;
 if(Lot>Max_Lot) Lot=Max_Lot;
 return(Lot);
//---
}
//+-----------------------------------------------------------------+
//|  : .  -   -  "http://wsforex.ru/"       |
//+-----------------------------------------------------------------+
string error(int eer)
{
   string er;
   switch(eer)
     {
      //---- 
      case 0:
      case 1:   er=" ,   ";                         break;
      case 2:   er=" ";                                                break;
      case 3:   er=" ";                                      break;
      case 4:   er="  ";                                       break;
      case 5:   er="   ";                         break;
      case 6:   er="    ";                               break;
      case 7:   er=" ";                                           break;
      case 8:   er="  ";                                      break;
      case 9:   er="    ";   break;
      case 64:  er=" ";                                           break;
      case 65:  er="  ";                                    break;
      case 128: er="    ";                       break;
      case 129: er=" ";                                           break;
      case 130: er=" ";                                          break;
      case 131: er=" ";                                          break;
      case 132: er=" ";                                                break;
      case 133: er=" ";                                          break;
      case 134: er="    ";                  break;
      case 135: er=" ";                                             break;
      case 136: er=" ";                                                     break;
      case 137: er=" ";                                                break;
      case 138: er="  - ";                                         break;
      case 139: er="    ";                     break;
      case 140: er="  ";                                    break;
      case 141: er="  ";                                      break;
      case 145: er=" ,       "; break;
      case 146: er="  ";                                  break;
      case 147: er="     ";      break;
      case 148: er="       ";  break;
      //---- 
      case 4000: er=" ";                                                 break;
      case 4001: er="  ";                             break;
      case 4002: er="  -  ";                             break;
      case 4003: er="    ";                               break;
      case 4004: er="    ";               break;
      case 4005: er="      ";                break;
      case 4006: er="    ";                        break;
      case 4007: er="    ";                            break;
      case 4008: er=" ";                                break;
      case 4009: er="   ";                      break;
      case 4010: er="    ";                          break;
      case 4011: er="  ";                                     break;
      case 4012: er="    ";                                 break;
      case 4013: er="  ";                                            break;
      case 4014: er=" ";                                        break;
      case 4015: er=" ";                                       break;
      case 4016: er=" ";                                break;
      case 4017: er=" DLL  ";                                    break;
      case 4018: er="  ";                            break;
      case 4019: er="  ";                                 break;
      case 4020: er="e     ";          break;
      case 4021: er="   ,   ";    break;
      case 4022: er=" ";                                             break;
      case 4050: er="   ";                 break;
      case 4051: er="   ";                    break;
      case 4052: er="   ";                        break;
      case 4053: er=" ";                                             break;
      case 4054: er="  -";               break;
      case 4055: er="  ";                        break;
      case 4056: er=" ";                                       break;
      case 4057: er="   ";                    break;
      case 4058: er="   ";                        break;
      case 4059: er="     ";                     break;
      case 4060: er="  ";                                    break;
      case 4061: er="  ";                                      break;
      case 4062: er="   string";                             break;
      case 4063: er="   integer";                            break;
      case 4064: er="   double";                             break;
      case 4065: er="    ";                      break;
      case 4066: er="     ";     break;
      case 4067: er="    ";                    break;
      case 4099: er=" ";                                                break;
      case 4100: er="    ";                                 break;
      case 4101: er="  ";                                     break;
      case 4102: er="   ";                              break;
      case 4103: er="  ";                                    break;
      case 4104: er="    ";                        break;
      case 4105: er="    ";                                    break;
      case 4106: er=" ";                                         break;
      case 4107: er="     ";            break;
      case 4108: er="  ";                                      break;
      case 4109: er="  ";                                      break;
      case 4110: er="   ";                               break;
      case 4111: er="   ";                              break;
      case 4200: er="  ";                                      break;
      case 4201: er="   ";                     break;
      case 4202: er="  ";                                       break;
      case 4203: er="  ";                                    break;
      case 4204: er="  ";                                          break;
      case 4205: er="  ";                                   break;
      case 4206: er="   ";                               break;
      case 4207: er="    ";                               break;
      default:   er="unknown error";
     }
  return(er);
}
//+-----------------------------------------------------------------+
//|  : .  -   -  "http://wsforex.ru/"       |
//+-----------------------------------------------------------------+

